#include "nbp.h"

int
get_cached_packet(int pkttype, BOOTPLAYER *pktptr)
{
	t_PXENV_GET_BINL_INFO gbi;

	gbi.packet_type = pkttype;
	gbi.buffer_size = sizeof(BOOTPLAYER);
	gbi.buffer_segment = _DS();
	gbi.buffer_offset = (UINT16)pktptr;

	if (pxe(PXENV_GET_BINL_INFO, &gbi, _SS())) {
		bputs("\nGET_BINL_INFO.Status == ");
		bputh4(gbi.Status);
		bputc('\n');

		return 0;
	}

	return 1;
}

int
set_cached_packet(int pkttype, BOOTPLAYER *pktptr)
{
	t_PXENV_GET_BINL_INFO gbi;

	gbi.packet_type = pkttype;
	gbi.buffer_size = 0;
	gbi.buffer_segment = 0;
	gbi.buffer_offset = 0;

	if (pxe(PXENV_GET_BINL_INFO, &gbi, _SS())) {
		bputs("\nGET_BINL_INFO.Status == ");
		bputh4(gbi.Status);
		bputc('\n');

		return 0;
	}

	if (!gbi.buffer_size || !gbi.buffer_segment)
		return 0;

	_fmemcpy(MK_FP(gbi.buffer_segment, gbi.buffer_offset),
		MK_FP(_DS(), pktptr), gbi.buffer_size);

	return 1;
}
